
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bsebus.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bsebus.hh>
#include <bse/bsetrack.hh>
#include <bse/bsesong.hh>
#include <bse/bseundostack.hh>


#line 12 "bsebus.proc"


/* --- connect-track --- */
static void
connect_track_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 14 "bsebus.proc"
 {
#line 16 "bsebus.proc"
  *(in_pspecs++)    = bse_param_spec_object ("sbus", NULL, NULL, BSE_TYPE_BUS, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("track", NULL, NULL, BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", NULL, NULL,
                                BSE_TYPE_ERROR_TYPE, Bse::ERROR_NONE, SFI_PARAM_STANDARD);
}
#line 21 "bsebus.proc"
 }
static Bse::ErrorType
#line 21 "bsebus.proc"
connect_track_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 24 "bsebus.proc"
{
#line 25 "bsebus.proc"
  
  BseBus *self = (BseBus*) bse_value_get_object (in_values++);
  BseTrack *track = (BseTrack*) bse_value_get_object (in_values++);
  Bse::ErrorType error = Bse::ERROR_NONE;

#line 30 "bsebus.proc"
  
  if (!BSE_IS_BUS (self) || !BSE_IS_TRACK (track))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 34 "bsebus.proc"
  
  if (!BSE_ITEM (self)->parent || BSE_ITEM (self)->parent != BSE_ITEM (track)->parent)
    error = Bse::ERROR_SOURCE_PARENT_MISMATCH;
  else
    {
      error = bse_bus_connect (self, BSE_ITEM (track));
      if (!error)
        bse_item_push_undo_proc (self, "disconnect-track", track);
    }

#line 44 "bsebus.proc"
  
  g_value_set_enum (out_values++, error);

  return Bse::ERROR_NONE;
}

/* --- disconnect-track --- */
static void
disconnect_track_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 50 "bsebus.proc"
 {
#line 52 "bsebus.proc"
  *(in_pspecs++)    = bse_param_spec_object ("sbus", NULL, NULL, BSE_TYPE_BUS, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("track", NULL, NULL, BSE_TYPE_TRACK, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", NULL, NULL,
                                BSE_TYPE_ERROR_TYPE, Bse::ERROR_NONE, SFI_PARAM_STANDARD);
}
#line 57 "bsebus.proc"
 }
static Bse::ErrorType
#line 57 "bsebus.proc"
disconnect_track_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 60 "bsebus.proc"
{
#line 61 "bsebus.proc"
  
  BseBus *self = (BseBus*) bse_value_get_object (in_values++);
  BseTrack *track = (BseTrack*) bse_value_get_object (in_values++);
  Bse::ErrorType error = Bse::ERROR_NONE;

#line 66 "bsebus.proc"
  
  if (!BSE_IS_BUS (self) || !BSE_IS_TRACK (track))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 70 "bsebus.proc"
  
  if (!BSE_ITEM (self)->parent || BSE_ITEM (self)->parent != BSE_ITEM (track)->parent)
    error = Bse::ERROR_SOURCE_PARENT_MISMATCH;
  else
    {
      error = bse_bus_disconnect (self, BSE_ITEM (track));
      if (!error)
        bse_item_push_undo_proc (self, "connect-track", track);
    }

  // FIXME: porting: grep for 'push_undo.*"disconnect-track"'

#line 82 "bsebus.proc"
  
  g_value_set_enum (out_values++, error);

  return Bse::ERROR_NONE;
}

/* --- connect-bus --- */
static void
connect_bus_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 88 "bsebus.proc"
 {
#line 90 "bsebus.proc"
  *(in_pspecs++)    = bse_param_spec_object ("sbus", NULL, NULL, BSE_TYPE_BUS, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("bus", NULL, NULL, BSE_TYPE_BUS, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", NULL, NULL,
                                BSE_TYPE_ERROR_TYPE, Bse::ERROR_NONE, SFI_PARAM_STANDARD);
}
#line 95 "bsebus.proc"
 }
static Bse::ErrorType
#line 95 "bsebus.proc"
connect_bus_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 98 "bsebus.proc"
{
#line 99 "bsebus.proc"
  
  BseBus *self = (BseBus*) bse_value_get_object (in_values++);
  BseBus *bus = (BseBus*) bse_value_get_object (in_values++);
  Bse::ErrorType error = Bse::ERROR_NONE;

#line 104 "bsebus.proc"
  
  if (!BSE_IS_BUS (self) || !BSE_IS_BUS (bus))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 108 "bsebus.proc"
  
  if (!BSE_ITEM (self)->parent || BSE_ITEM (self)->parent != BSE_ITEM (bus)->parent)
    error = Bse::ERROR_SOURCE_PARENT_MISMATCH;
  else
    {
      error = bse_bus_connect (self, BSE_ITEM (bus));
      if (!error)
        bse_item_push_undo_proc (self, "disconnect-bus", bus);
    }

#line 118 "bsebus.proc"
  
  g_value_set_enum (out_values++, error);

  return Bse::ERROR_NONE;
}

/* --- disconnect-bus --- */
static void
disconnect_bus_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 124 "bsebus.proc"
 {
#line 126 "bsebus.proc"
  *(in_pspecs++)    = bse_param_spec_object ("sbus", NULL, NULL, BSE_TYPE_BUS, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("bus", NULL, NULL, BSE_TYPE_BUS, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", NULL, NULL,
                                BSE_TYPE_ERROR_TYPE, Bse::ERROR_NONE, SFI_PARAM_STANDARD);
}
#line 131 "bsebus.proc"
 }
static Bse::ErrorType
#line 131 "bsebus.proc"
disconnect_bus_exec (BseProcedureClass *proc,
      const GValue      *in_values,
      GValue            *out_values)
#line 134 "bsebus.proc"
{
#line 135 "bsebus.proc"
  
  BseBus *self = (BseBus*) bse_value_get_object (in_values++);
  BseBus *bus = (BseBus*) bse_value_get_object (in_values++);
  Bse::ErrorType error = Bse::ERROR_NONE;

#line 140 "bsebus.proc"
  
  if (!BSE_IS_BUS (self) || !BSE_IS_BUS (bus))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 144 "bsebus.proc"
  
  if (!BSE_ITEM (self)->parent || BSE_ITEM (self)->parent != BSE_ITEM (bus)->parent)
    error = Bse::ERROR_SOURCE_PARENT_MISMATCH;
  else
    {
      error = bse_bus_disconnect (self, BSE_ITEM (bus));
      if (!error)
        bse_item_push_undo_proc (self, "connect-bus", bus);
    }

#line 154 "bsebus.proc"
  
  g_value_set_enum (out_values++, error);

  return Bse::ERROR_NONE;
}

/* --- Export to BSE --- */
static void
__enode_connect_track__fill_strings (BseExportStrings *es)
{
  es->blurb = _("Add a track to the input list of a bus.");
  es->file = "/opt/src/beast/bse/bsebus.proc";
  es->line = 15;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2004 Tim Janik";
}
static BseExportNodeProc __enode_connect_track = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseBus+connect-track", 
    NULL,
    "/Methods/BseBus/General/Connect Track",
    NULL,
    __enode_connect_track__fill_strings,
  },
  0, connect_track_setup, connect_track_exec, 
};
static void
__enode_disconnect_track__fill_strings (BseExportStrings *es)
{
  es->blurb = _("Remove a track from the input list of a bus.");
  es->file = "/opt/src/beast/bse/bsebus.proc";
  es->line = 51;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2004 Tim Janik";
}
static BseExportNodeProc __enode_disconnect_track = {
  { (BseExportNode*) &__enode_connect_track, BSE_EXPORT_NODE_PROC,
    "BseBus+disconnect-track", 
    NULL,
    "/Methods/BseBus/General/Disconnect Track",
    NULL,
    __enode_disconnect_track__fill_strings,
  },
  0, disconnect_track_setup, disconnect_track_exec, 
};
static void
__enode_connect_bus__fill_strings (BseExportStrings *es)
{
  es->blurb = _("Add a bus to the input list of a bus.");
  es->file = "/opt/src/beast/bse/bsebus.proc";
  es->line = 89;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2004 Tim Janik";
}
static BseExportNodeProc __enode_connect_bus = {
  { (BseExportNode*) &__enode_disconnect_track, BSE_EXPORT_NODE_PROC,
    "BseBus+connect-bus", 
    NULL,
    "/Methods/BseBus/General/Connect Bus",
    NULL,
    __enode_connect_bus__fill_strings,
  },
  0, connect_bus_setup, connect_bus_exec, 
};
static void
__enode_disconnect_bus__fill_strings (BseExportStrings *es)
{
  es->blurb = _("Remove a bus from the input list of a bus.");
  es->file = "/opt/src/beast/bse/bsebus.proc";
  es->line = 125;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "Copyright (C) 2004 Tim Janik";
}
static BseExportNodeProc __enode_disconnect_bus = {
  { (BseExportNode*) &__enode_connect_bus, BSE_EXPORT_NODE_PROC,
    "BseBus+disconnect-bus", 
    NULL,
    "/Methods/BseBus/General/Disconnect Bus",
    NULL,
    __enode_disconnect_bus__fill_strings,
  },
  0, disconnect_bus_setup, disconnect_bus_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bsebus_genprc_cc (void)
{
  return (BseExportNode*) &__enode_disconnect_bus;
}

/*
 * Generated data ends here
 */
