
/*
 * Generated data (by mkcproc.pl)
 */
#line 1 "bseproject.proc"
// Licensed GNU LGPL v2.1 or later: http://www.gnu.org/licenses/lgpl.html
#include <bse/bseplugin.hh>
#include <bse/bseprocedure.hh>
#include <bse/bseproject.hh>
#include <bse/bsestorage.hh>
#include <bse/bsesong.hh>
#include <bse/bseundostack.hh>
#include <bse/bsewaverepo.hh>
#include <bse/bsecsynth.hh>
#include <bse/bsemidisynth.hh>
#include <bse/bsedatapocket.hh>
#include <bse/bsemidifile.hh>
#include <bse/bsemidireceiver.hh>
#include <bse/bsemidinotifier.hh>
#include <bse/bseengine.hh>
#include "bsecxxplugin.hh"


#line 21 "bseproject.proc"



/* --- get-midi-notifier --- */
static void
get_midi_notifier_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 24 "bseproject.proc"
 {
#line 26 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", NULL, BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("midi_notifier", NULL, NULL, BSE_TYPE_MIDI_NOTIFIER, SFI_PARAM_STANDARD);
#line 28 "bseproject.proc"
}  }
static Bse::ErrorType
#line 28 "bseproject.proc"
get_midi_notifier_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 31 "bseproject.proc"
{
#line 32 "bseproject.proc"
  
  BseProject *self = (BseProject*) bse_value_get_object (in_values++);

#line 35 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (self))
    return Bse::ERROR_PROC_PARAM_INVAL;

  BseMidiNotifier *notifier = bse_project_get_midi_notifier (self);

#line 41 "bseproject.proc"
  
  bse_value_set_object (out_values++, G_OBJECT (notifier));

  return Bse::ERROR_NONE;
}



/* --- store-bse --- */
static void
store_bse_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 49 "bseproject.proc"
 {
#line 52 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", NULL,
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("super", "Super", NULL,
                                 BSE_TYPE_SUPER, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("file-name", "File", "Destination file name",
                            NULL, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_bool ("self-contained", "Self Contained",
                          "Whether references to other objects (e.g. samples) should "
                          "be stored or whether to include everything in a self-contained .bse file",
                          FALSE, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("error", "Error", "Error indicating possible failures",
                                BSE_TYPE_ERROR_TYPE, Bse::ERROR_NONE,
                                SFI_PARAM_STANDARD);
#line 65 "bseproject.proc"
}  }
static Bse::ErrorType
#line 65 "bseproject.proc"
store_bse_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 68 "bseproject.proc"
{
#line 69 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  BseSuper *super = (BseSuper*) bse_value_get_object (in_values++);
  const char *file_name = sfi_value_get_string (in_values++);
  gboolean self_contained = sfi_value_get_bool (in_values++);
  Bse::ErrorType error;

#line 76 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project) || !file_name)
    return Bse::ERROR_PROC_PARAM_INVAL;
  if (super && BSE_ITEM (super)->parent != BSE_ITEM (project))
    return Bse::ERROR_PROC_PARAM_INVAL;

  error = bse_project_store_bse (project, super, file_name, self_contained);

#line 84 "bseproject.proc"
  
  g_value_set_enum (out_values++, error);

  return Bse::ERROR_NONE;
}

/* --- create-song --- */
static void
create_song_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 90 "bseproject.proc"
 {
#line 92 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("name", "Name", "Song name",
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("song", "Song", "The new song",
                                 BSE_TYPE_SONG, SFI_PARAM_STANDARD);
#line 98 "bseproject.proc"
}  }
static Bse::ErrorType
#line 98 "bseproject.proc"
create_song_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 101 "bseproject.proc"
{
#line 102 "bseproject.proc"
  
  BseContainer *container = (BseContainer*) bse_value_get_object (in_values++);
  const char *name = sfi_value_get_string (in_values++);
  BseUndoStack *ustack;
  BseItem *child;

#line 108 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (container))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 112 "bseproject.proc"
  
  ustack = bse_item_undo_open (container, "create-song");
  child = (BseItem*) bse_container_new_child (container, BSE_TYPE_SONG, NULL);
  if (name)
    bse_item_set (child, "uname", name, NULL);
  bse_item_push_undo_proc (container, "remove-snet", child);
  bse_item_undo_close (ustack);

#line 120 "bseproject.proc"
  
  bse_value_set_object (out_values++, child);

  return Bse::ERROR_NONE;
}

/* --- get-wave-repo --- */
static void
get_wave_repo_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 126 "bseproject.proc"
 {
#line 128 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("wrepo", "Wave Repo", "The project's unique wave repo",
                                 BSE_TYPE_WAVE_REPO, SFI_PARAM_STANDARD);
#line 132 "bseproject.proc"
}  }
static Bse::ErrorType
#line 132 "bseproject.proc"
get_wave_repo_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 135 "bseproject.proc"
{
#line 136 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  BseWaveRepo *wrepo = NULL;

#line 140 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 144 "bseproject.proc"
  
  wrepo = bse_project_get_wave_repo (project);

#line 147 "bseproject.proc"
  
  bse_value_set_object (out_values++, wrepo);

  return Bse::ERROR_NONE;
}

/* --- get-data-pocket --- */
static void
get_data_pocket_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 153 "bseproject.proc"
 {
#line 155 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("name", "Name", "Name of the data pocket",
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("data_pocket", "Data Pocket", "The data pocket",
                                 BSE_TYPE_DATA_POCKET, SFI_PARAM_STANDARD);
#line 161 "bseproject.proc"
}  }
static Bse::ErrorType
#line 161 "bseproject.proc"
get_data_pocket_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 164 "bseproject.proc"
{
#line 165 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  const char *name = sfi_value_get_string (in_values++);
  BseItem *item;

#line 170 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project) || !name)
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 174 "bseproject.proc"
  
  item = bse_project_lookup_typed_item (project, BSE_TYPE_DATA_POCKET, name);
  if (!item)
    item = (BseItem*) bse_container_new_child (BSE_CONTAINER (project), BSE_TYPE_DATA_POCKET, "uname", name, NULL);

#line 179 "bseproject.proc"
  
  bse_value_set_object (out_values++, item);

  return Bse::ERROR_NONE;
}

/* --- create-csynth --- */
static void
create_csynth_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 185 "bseproject.proc"
 {
#line 187 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("name", "Name", "Synth network name",
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("csynth", "Synthesizer Network", "New synth network",
                                 BSE_TYPE_CSYNTH, SFI_PARAM_STANDARD);
#line 193 "bseproject.proc"
}  }
static Bse::ErrorType
#line 193 "bseproject.proc"
create_csynth_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 196 "bseproject.proc"
{
#line 197 "bseproject.proc"
  
  BseContainer *container = (BseContainer*) bse_value_get_object (in_values++);
  const char *name = sfi_value_get_string (in_values++);
  BseUndoStack *ustack;
  BseItem *child;

#line 203 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (container))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 207 "bseproject.proc"
  
  ustack = bse_item_undo_open (container, "create-csynth");
  child = (BseItem*) bse_container_new_child (container, BSE_TYPE_CSYNTH, NULL);
  if (name)
    bse_item_set (child, "uname", name, NULL);
  bse_item_push_undo_proc (container, "remove-snet", child);
  bse_item_undo_close (ustack);

#line 215 "bseproject.proc"
  
  bse_value_set_object (out_values++, child);

  return Bse::ERROR_NONE;
}

/* --- create-midi-synth --- */
static void
create_midi_synth_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 221 "bseproject.proc"
 {
#line 223 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("name", "Name", "MIDI synth name",
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("midi_synth", "MIDI Synthesizer", "New MIDI synth",
                                 BSE_TYPE_MIDI_SYNTH, SFI_PARAM_STANDARD);
#line 229 "bseproject.proc"
}  }
static Bse::ErrorType
#line 229 "bseproject.proc"
create_midi_synth_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 232 "bseproject.proc"
{
#line 233 "bseproject.proc"
  
  BseContainer *container = (BseContainer*) bse_value_get_object (in_values++);
  const char *name = sfi_value_get_string (in_values++);
  BseUndoStack *ustack;
  BseItem *child;

#line 239 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (container))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 243 "bseproject.proc"
  
  ustack = bse_item_undo_open (container, "create-midi-synth");
  child = (BseItem*) bse_container_new_child (container, BSE_TYPE_MIDI_SYNTH, NULL);
  if (name)
    bse_item_set (child, "uname", name, NULL);
  bse_item_push_undo_proc (container, "remove-snet", child);
  bse_item_undo_close (ustack);

#line 251 "bseproject.proc"
  
  bse_value_set_object (out_values++, child);

  return Bse::ERROR_NONE;
}

/* --- remove-snet --- */
static void
remove_snet_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 257 "bseproject.proc"
 {
#line 259 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = bse_param_spec_object ("snet", "SNet", "Synthesizer Network",
                                 BSE_TYPE_SNET, SFI_PARAM_STANDARD);
#line 263 "bseproject.proc"
}  }
static Bse::ErrorType
#line 263 "bseproject.proc"
remove_snet_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 266 "bseproject.proc"
{
#line 267 "bseproject.proc"
  
  BseContainer *self = (BseContainer*) bse_value_get_object (in_values++);
  BseItem *child = (BseItem*) bse_value_get_object (in_values++);
  BseUndoStack *ustack;

#line 272 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (self) || !BSE_IS_SNET (child) || child->parent != (BseItem*) self)
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 276 "bseproject.proc"
  
  if (!BSE_SOURCE_PREPARED (self))
    {
      ustack = bse_item_undo_open (self, "remove-child %s", bse_object_debug_name (child));
#line 280 "bseproject.proc"
      
      bse_container_uncross_undoable (BSE_CONTAINER (self), child);
#line 282 "bseproject.proc"
      
      bse_item_push_redo_proc (self, "remove-snet", child);
#line 284 "bseproject.proc"
      
      bse_container_remove_backedup (BSE_CONTAINER (self), child, ustack);
#line 286 "bseproject.proc"
      
      bse_item_undo_close (ustack);
    }

  return Bse::ERROR_NONE;
}

/* --- list-uname-paths --- */
static void
list_uname_paths_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 293 "bseproject.proc"
 {
#line 296 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", NULL, NULL,
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("item_type", NULL, NULL,
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("uname_paths", "Uname Paths", NULL, BSE_TYPE_STRING_SEQ, SFI_PARAM_STANDARD);
#line 301 "bseproject.proc"
}  }
static Bse::ErrorType
#line 301 "bseproject.proc"
list_uname_paths_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 304 "bseproject.proc"
{
#line 305 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  const gchar *tname  = sfi_value_get_string (in_values++);
  GType type          = tname ? g_type_from_name (tname) : 0;

#line 310 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project) || !g_type_is_a (type, BSE_TYPE_ITEM))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 314 "bseproject.proc"
  
  bse_value_take_boxed (out_values++, bse_project_list_upaths (project, type));

  return Bse::ERROR_NONE;
}

/* --- find-item --- */
static void
find_item_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 320 "bseproject.proc"
 {
#line 322 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", NULL, NULL,
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("uname_path", NULL, NULL,
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_object ("item", NULL, NULL,
                                 BSE_TYPE_ITEM, SFI_PARAM_STANDARD);
#line 328 "bseproject.proc"
}  }
static Bse::ErrorType
#line 328 "bseproject.proc"
find_item_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 331 "bseproject.proc"
{
#line 332 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  const gchar *string = sfi_value_get_string (in_values++);

#line 336 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project) || !string)
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 340 "bseproject.proc"
  
  bse_value_set_object (out_values++, bse_container_resolve_upath (BSE_CONTAINER (project), string));

  return Bse::ERROR_NONE;
}

/* --- match-items-by-uname --- */
static void
match_items_by_uname_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 346 "bseproject.proc"
 {
#line 348 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", NULL, NULL,
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("item_type", NULL, NULL,
                            NULL, SFI_PARAM_STANDARD);
  *(in_pspecs++)    = sfi_pspec_string ("uname", NULL, NULL,
                            NULL, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("item_list", "Item List", NULL, BSE_TYPE_ITEM_SEQ, SFI_PARAM_STANDARD);
#line 355 "bseproject.proc"
}  }
static Bse::ErrorType
#line 355 "bseproject.proc"
match_items_by_uname_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 358 "bseproject.proc"
{
#line 359 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  const gchar *tname  = sfi_value_get_string (in_values++);
  const gchar *string = sfi_value_get_string (in_values++);
  GType type          = tname ? g_type_from_name (tname) : 0;
  GList *list, *free_list;
  BseItemSeq *iseq;

#line 367 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project) || !string || !g_type_is_a (type, BSE_TYPE_ITEM))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 371 "bseproject.proc"
  
  iseq = bse_item_seq_new ();
  free_list = bse_objects_list_by_uname (type, string);
  for (list = free_list; list; list = list->next)
    if (bse_item_get_project ((BseItem*) list->data) == project)
      {
        bse_item_seq_append (iseq, (BseItem*) list->data);
        break;
      }
  g_list_free (free_list);

#line 382 "bseproject.proc"
  
  bse_value_take_boxed (out_values++, iseq);

  return Bse::ERROR_NONE;
}

/* --- get-supers --- */
static void
get_supers_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 388 "bseproject.proc"
 {
#line 390 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", NULL, NULL,
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_boxed ("super_list", NULL, NULL, BSE_TYPE_ITEM_SEQ, SFI_PARAM_STANDARD);
#line 393 "bseproject.proc"
}  }
static Bse::ErrorType
#line 393 "bseproject.proc"
get_supers_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 396 "bseproject.proc"
{
#line 397 "bseproject.proc"
  
  BseProject *project = (BseProject*) bse_value_get_object (in_values++);
  BseItemSeq *iseq;
  GSList *slist;

#line 402 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (project))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 406 "bseproject.proc"
  
  iseq = bse_item_seq_new ();
  for (slist = project->supers; slist; slist = slist->next)
    bse_item_seq_append (iseq, (BseItem*) slist->data);

#line 411 "bseproject.proc"
  
  bse_value_take_boxed (out_values++, iseq);

  return Bse::ERROR_NONE;
}


/* --- get-state --- */
static void
get_state_setup (BseProcedureClass *proc, GParamSpec **in_pspecs, GParamSpec **out_pspecs) {
#line 418 "bseproject.proc"
 {
#line 420 "bseproject.proc"
  *(in_pspecs++)    = bse_param_spec_object ("project", "Project", "The project",
                                 BSE_TYPE_PROJECT, SFI_PARAM_STANDARD);
  *(out_pspecs++)   = bse_param_spec_genum ("state", "State", "Project playback/activation state",
                                BSE_TYPE_PROJECT_STATE, BSE_PROJECT_INACTIVE, SFI_PARAM_STANDARD);
#line 424 "bseproject.proc"
}  }
static Bse::ErrorType
#line 424 "bseproject.proc"
get_state_exec (BseProcedureClass *proc,
        const GValue      *in_values,
        GValue            *out_values)
#line 427 "bseproject.proc"
{
#line 428 "bseproject.proc"
  
  BseProject *self = (BseProject*) bse_value_get_object (in_values++);

#line 431 "bseproject.proc"
  
  if (!BSE_IS_PROJECT (self))
    return Bse::ERROR_PROC_PARAM_INVAL;

#line 435 "bseproject.proc"
  
  g_value_set_enum (out_values++, self->state);

  return Bse::ERROR_NONE;
}



/* --- Export to BSE --- */
static void
__enode_get_midi_notifier__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve the project's midi notifier object.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 25;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_midi_notifier = {
  { NULL, BSE_EXPORT_NODE_PROC,
    "BseProject+get-midi-notifier", 
    NULL,
    "/Methods/BseProject/General/Get Midi Notifier",
    NULL,
    __enode_get_midi_notifier__fill_strings,
  },
  0, get_midi_notifier_setup, get_midi_notifier_exec, 
};
static void
__enode_store_bse__fill_strings (BseExportStrings *es)
{
  es->blurb = "Save supers of a project into a BSE file. "
          "If no super is specified, the project itself is stored.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 50;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_store_bse = {
  { (BseExportNode*) &__enode_get_midi_notifier, BSE_EXPORT_NODE_PROC,
    "BseProject+store-bse", 
    NULL,
    "/Methods/BseProject/File/Store",
    NULL,
    __enode_store_bse__fill_strings,
  },
  0, store_bse_setup, store_bse_exec, 
};
static void
__enode_create_song__fill_strings (BseExportStrings *es)
{
  es->blurb = "Create a song for this project.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 91;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_create_song = {
  { (BseExportNode*) &__enode_store_bse, BSE_EXPORT_NODE_PROC,
    "BseProject+create-song", 
    NULL,
    "/Methods/BseProject/General/Create Song",
    NULL,
    __enode_create_song__fill_strings,
  },
  0, create_song_setup, create_song_exec, 
};
static void
__enode_get_wave_repo__fill_strings (BseExportStrings *es)
{
  es->blurb = "Ensure the project has a wave repository";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 127;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_wave_repo = {
  { (BseExportNode*) &__enode_create_song, BSE_EXPORT_NODE_PROC,
    "BseProject+get-wave-repo", 
    NULL,
    "/Methods/BseProject/General/Get Wave Repo",
    NULL,
    __enode_get_wave_repo__fill_strings,
  },
  0, get_wave_repo_setup, get_wave_repo_exec, 
};
static void
__enode_get_data_pocket__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve a specifically named data pocket for this project";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 154;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_data_pocket = {
  { (BseExportNode*) &__enode_get_wave_repo, BSE_EXPORT_NODE_PROC,
    "BseProject+get-data-pocket", 
    NULL,
    "/Methods/BseProject/General/Get Data Pocket",
    NULL,
    __enode_get_data_pocket__fill_strings,
  },
  0, get_data_pocket_setup, get_data_pocket_exec, 
};
static void
__enode_create_csynth__fill_strings (BseExportStrings *es)
{
  es->blurb = "Create a synthsizer network for this project.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 186;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_create_csynth = {
  { (BseExportNode*) &__enode_get_data_pocket, BSE_EXPORT_NODE_PROC,
    "BseProject+create-csynth", 
    NULL,
    "/Methods/BseProject/General/Create Csynth",
    NULL,
    __enode_create_csynth__fill_strings,
  },
  0, create_csynth_setup, create_csynth_exec, 
};
static void
__enode_create_midi_synth__fill_strings (BseExportStrings *es)
{
  es->blurb = "Create a MIDI synthesizer network for this project.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 222;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_create_midi_synth = {
  { (BseExportNode*) &__enode_create_csynth, BSE_EXPORT_NODE_PROC,
    "BseProject+create-midi-synth", 
    NULL,
    "/Methods/BseProject/General/Create Midi Synth",
    NULL,
    __enode_create_midi_synth__fill_strings,
  },
  0, create_midi_synth_setup, create_midi_synth_exec, 
};
static void
__enode_remove_snet__fill_strings (BseExportStrings *es)
{
  es->blurb = "Remove an existing synthesizer network from this project.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 258;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_remove_snet = {
  { (BseExportNode*) &__enode_create_midi_synth, BSE_EXPORT_NODE_PROC,
    "BseProject+remove-snet", 
    NULL,
    "/Methods/BseProject/General/Remove Snet",
    NULL,
    __enode_remove_snet__fill_strings,
  },
  0, remove_snet_setup, remove_snet_exec, 
};
static void
__enode_list_uname_paths__fill_strings (BseExportStrings *es)
{
  es->blurb = ("List uname paths for all items of a specified type within this project. "
           "By their uname paths, items are uniquely identifyable within a project.");
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 294;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_list_uname_paths = {
  { (BseExportNode*) &__enode_remove_snet, BSE_EXPORT_NODE_PROC,
    "BseProject+list-uname-paths", 
    NULL,
    "/Methods/BseProject/General/List Uname Paths",
    NULL,
    __enode_list_uname_paths__fill_strings,
  },
  0, list_uname_paths_setup, list_uname_paths_exec, 
};
static void
__enode_find_item__fill_strings (BseExportStrings *es)
{
  es->blurb = "Find an item within a project, given its uname path.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 321;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_find_item = {
  { (BseExportNode*) &__enode_list_uname_paths, BSE_EXPORT_NODE_PROC,
    "BseProject+find-item", 
    NULL,
    "/Methods/BseProject/General/Find Item",
    NULL,
    __enode_find_item__fill_strings,
  },
  0, find_item_setup, find_item_exec, 
};
static void
__enode_match_items_by_uname__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve all items of a specific type within a project with matching uname";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 347;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_match_items_by_uname = {
  { (BseExportNode*) &__enode_find_item, BSE_EXPORT_NODE_PROC,
    "BseProject+match-items-by-uname", 
    NULL,
    "/Methods/BseProject/General/Match Items By Uname",
    NULL,
    __enode_match_items_by_uname__fill_strings,
  },
  0, match_items_by_uname_setup, match_items_by_uname_exec, 
};
static void
__enode_get_supers__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve all supers of this project.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 389;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_supers = {
  { (BseExportNode*) &__enode_match_items_by_uname, BSE_EXPORT_NODE_PROC,
    "BseProject+get-supers", 
    NULL,
    "/Methods/BseProject/General/Get Supers",
    NULL,
    __enode_get_supers__fill_strings,
  },
  0, get_supers_setup, get_supers_exec, 
};
static void
__enode_get_state__fill_strings (BseExportStrings *es)
{
  es->blurb = "Retrieve the current project state.";
  es->file = "/opt/src/beast/bse/bseproject.proc";
  es->line = 419;
  es->authors = "Tim Janik <timj@gtk.org>";
  es->license = "GNU Lesser General Public License";
}
static BseExportNodeProc __enode_get_state = {
  { (BseExportNode*) &__enode_get_supers, BSE_EXPORT_NODE_PROC,
    "BseProject+get-state", 
    NULL,
    "/Methods/BseProject/General/Get State",
    NULL,
    __enode_get_state__fill_strings,
  },
  0, get_state_setup, get_state_exec, 
};
extern "C" BseExportNode* bse__builtin_init_bseproject_genprc_cc (void)
{
  return (BseExportNode*) &__enode_get_state;
}

/*
 * Generated data ends here
 */
